%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Bousi-Prolog interactive system launcher

:- module(bousi, [
		main/0                  %
   ]).

:- use_module(bplShell).
:- use_module(foreign).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Main predicate for launching the Bousi-Prolog system
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% main
%
%     Initial predicate of the Bousi-Prolog system. This predicate
%     loads the foreign library, shows a welcome message and
%     initializes and launches the Bousi-Prolog command-line shell.
%

main :-
	foreign:load_foreign_extension,
	welcome_message,
	bplShell:start_bpl_shell.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Miscellaneous predicates
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%% welcome_message
%
%     Shows Bousi-Prolog initial welcome message.
%

welcome_message :-
  nl,
  write('                                                    Universidad de'), nl,
  write('|O)               |D)                            Castilla - La Mancha'), nl,
  write('|O)(O)\\U(S)|I| ~~ || |R (O) |L (O) (G|.    (Version 2.01 ~~ April 2018)'), nl,
  write('----------------------------------------------------------------------------'), nl,
  write('Welcome to Bousi~Prolog, a fuzzy logic programming system created by'), nl,
  write('Juan Gallardo-Casero and Pascual Julian-Iranzo, from Castilla-La Mancha'), nl,
  write('University, and the contribution of Fernando Saenz-Perez from Complutense'), nl,
  write('University of Madrid. This software is for research and educational purposes'), nl,
  write('only and it is distributed with NO WARRANTY. Please visit our website for '), nl,
  write('the latest news on Bousi~Prolog (http://dectau.uclm.es/bousi)'), nl,
  write('----------------------------------------------------------------------------'), nl,
  nl,
  write('----------------------------------------------------------------------------'), nl,
  write('--            Enter \'hp\' to get help on the available commands            --'), nl,
  write('----------------------------------------------------------------------------'), nl,
  nl.

